# Remote Control Plugin

This unofficial TaleSpire allows players to collaboratively draw on the Talepire screen.

Video Demo: https://youtu.be/mw0H8c3oeGY

This plugin, like all others, is free but if you want to donate, use: http://198.91.243.185/TalespireDonate/Donate.php

## Change Log

```
1.0.0: Initial release
```

## Install

Use R2ModMan or similar installer to install this plugin.

Use R2ModMan Edit Config to tweak parameters of the plugin such as the background/erase color and the size of the overlay.

## Usage

While Talespire is running the GM can open Overlay more by pressing the Overaly keyboard shortcut (Default RCTRL+O).
Overlay Mode is indicated by the Overlay Mode menu in the to right in case the background color is set to transparent
(as is the default for the background).

### Click Mode (Preferred)

Left mouse click on a point and then left mouse click on another point. The points are connected by a line of the current
pencil color. Left mouse click again to connect the last point and the new click point with a line of the pencil color.

To end the current line, click the middle mouse button.

### Drag Mode (Discouraged)

Hold the left mouse button and drag the mouse. The path that the mouse pointer was dragged will be filled in with connected
lines duplicating the path. 

To end the current line, click the middle mouse button.

This mode produces a lot more information that needs to be sent through the network and processed by all player devices.
As such players with slower devices may not appreciate this mode because it will take longer to update and thus produce
more lag.

### Eraser Mode

Clicking or dragging the right mouse button erases part of the overlay around the mouse pointer. Unlike the draw modes
the eraser mode does not connect with the previous point, it erases purely around the mouse pointer.

### Menu: X

The X button in the Overlay Menu is used to close the overlay. Note that the drawn image is retained when the overlay
is closed. If the overlay is re-opened the previously drawn content will be shown.

### Menu: /

The / button in the Overlay Menu is used to clear the currently drawn content for eveyone. Warning: There is no undo.

### Menu: C

The C button in the Overlay Menu is used select a new pen color. Currently it is a very simple dialog box which expects
a string in the format A,R,G,B with each value being a value from 0 to 255. The A value is the alpha value. A value of 0
for the alpha value means fully transparent while a value of 255 means fully opaque. The rest of the values are the R (Red),
G (Green) and B (Blue) components of the color. Values of 0 means no contribution from that color and values of 255 means
full contribution from that color. 


## Limitations

1. Click to draw are also processed by Talespire. Thus clicking on a mini while drawing will still select it and erasing
   will move the camera. There is no current work around for this.
2. Initial click of a line does not show where you clicked until you click a second point.
3. Views of the players are not synchronized by the overlay plugin so using the overlay to indicate features can be
   misleading because player can be looking at the scene (or not even look at the same part of the scene).